package org.gcube.data.analysis.tabulardata.expression.evaluator.sql.evaluators.text;

import org.gcube.data.analysis.tabulardata.expression.composite.text.SubstringPosition;
import org.gcube.data.analysis.tabulardata.expression.evaluator.BaseExpressionEvaluator;
import org.gcube.data.analysis.tabulardata.expression.evaluator.Evaluator;
import org.gcube.data.analysis.tabulardata.expression.evaluator.EvaluatorException;
import org.gcube.data.analysis.tabulardata.expression.evaluator.sql.SQLExpressionEvaluatorFactory;

public class SubstringPositionEvaluator extends BaseExpressionEvaluator<SubstringPosition> implements Evaluator<String>{

	private SQLExpressionEvaluatorFactory factory;

	public SubstringPositionEvaluator(SubstringPosition expression,
			SQLExpressionEvaluatorFactory factory) {
		super(expression);
		this.factory = factory;
	}

	@Override
	public String evaluate() throws EvaluatorException {
		return String.format("(position(%s in %s))", 
				factory.getEvaluator(expression.getRightArgument()).evaluate(),
				factory.getEvaluator(expression.getLeftArgument()).evaluate());
	}
}
